


// ======================================================================================================

// This is a pure virtual class (what does it mean?)
// Its purpose is to define an interface for all handlers.

class THandler
{
	private:

		THandler * fNext;		// a link to the next handler

	public:

		///////////////////////////////////////////////////////////
		// Class default constructor
		///////////////////////////////////////////////////////////
		//		
		// INPUT:
		//			none
		//		
		// OUTPUT:
		//			
		//		
		// REMARKS:
		//		
		//		
		THandler( void ) : fNext( 0 ) {}

		virtual ~THandler() {}

	public:

		THandler * GetNext( void ) { return fNext; }

		void SetNext( THandler * h ) { fNext = h; }

	public:

		///////////////////////////////////////////////////////////
		// A functor
		///////////////////////////////////////////////////////////
		//		
		// INPUT:
		//			none
		//		
		// OUTPUT:
		//			none
		//		
		// REMARKS:
		//			Will be defined in the derived classes
		//		
		virtual void operator () ( void ) = 0;		// pure virtual - cannot create THandler object


};	

	
// ======================================================================================================
